﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.DataVisualization.Charting;

namespace asgn1
{
    public partial class Sales : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            //set up defaults for chart
            SalesChart.DataSource = ByTypeSalesDataSource;
            SalesChart.Series[0].XValueMember = "type";
            SalesChart.Series[0].YValueMembers = "Sum_ytd_sales";
            SalesChart.Titles.FindByName("ChartTitle").Text = "Year-to-Date Sales by Book Type";
            SalesChart.Series[0].ChartType = SeriesChartType.Column;
        }

        //set the chart source and type when either the source or type is changed
        //thus ensuring that both selections are reflected
        protected void GroupByDropDownList_SelectedIndexChanged(object sender, EventArgs e)
        {
            changeCharts();        
        }
        protected void ChartTypeDropDownList_SelectedIndexChanged(object sender, EventArgs e)
        {
            changeCharts();
        }

        private void changeCharts() 
        {
            //1. set the chart data
            string groupBy = GroupByDropDownList.SelectedValue;
            switch (groupBy)
            {
                case "Publisher":
                    SalesChart.DataSource = ByPublisherSalesDataSource;
                    SalesChart.Series[0].XValueMember = "pub_name";
                    SalesChart.Series[0].YValueMembers = "Expr1";//this one is so complicated, Avril can't even sing about it
                    SalesChart.Titles.FindByName("ChartTitle").Text = "Year-to-Date Sales by Publisher";
                    break;
                case "Price":
                    SalesChart.DataSource = ByPriceSalesDataSource;
                    SalesChart.Series[0].XValueMember = "pricerange";
                    SalesChart.Series[0].YValueMembers = "ytdsold";
                    SalesChart.Titles.FindByName("ChartTitle").Text = "Year-to-Date sales by Price Range";
                    break;
                default://"Type"
                    SalesChart.DataSource = ByTypeSalesDataSource;
                    SalesChart.Series[0].XValueMember = "type";
                    SalesChart.Series[0].YValueMembers = "Sum_ytd_sales";
                    SalesChart.Titles.FindByName("ChartTitle").Text = "Year-to-Date Sales by Book Type";
                    break;
            }

            //2. set the chart type
            string chartType = ChartTypeDropDownList.SelectedValue;
            switch (chartType)
            {
                case "Bar":
                    SalesChart.Series[0].ChartType = SeriesChartType.Bar;
                    break;
                case "Pie":
                    SalesChart.Series[0].ChartType = SeriesChartType.Pie;
                    break;
                default://"Column"
                    SalesChart.Series[0].ChartType = SeriesChartType.Column;
                    break;
            }
        }
    }
}